// Для ArduinoMega 2560
#define sensorPin A0                    // Нога для фоторезистора;
#define ledNight 24                     // Нога для LED - показывает включение ночного режима;
unsigned int sensorValue = 0;           // Переменная для снятия показаний сенсора освещенности;
unsigned int sensorRef = 1010;          // Референсное значение сенсора освещенности, выше которого считается ночь;
boolean night = 0;                      // Если 1 - то ночь;
//PWM ноги ArduinoMega 2560 от 2 до 13 и от 44 до 46;

int OutPins[15] = {2,3,4,5,6,7,8,9,10,11,12,13,44,45,46}; // Массив PWM ног;

// Подсветка;
int i;                                  // Счетчик для зажигания и тушения диодов, определения день/ночь;
#define timer 20                        //Таймер для задержек при включении/выключении последовательности ступенек;
#define SwitchOffDelay 15000            // Задержка выключения посветки;
#define SwitchOnBright 150              // Яркость включенных ступенек, максимально - 255;
#define NightBright  20                 // Яркость подсвеченных ступенек в ночном режиме (первая, последняя);
int timeForBlink = 10;              // Число циклов мерцания включенной подсветки, баловство;

//SEN00 - нижний ультрасоник;
#define pingPin00 30                    // PWM Выход;

//SEN01 - верхний ультрасоник;
#define pingPin01 32                    // PWM Выход;

#define LedUltra 25                     // Нога светодиода - в ночном режиме показывает что любой ультрасоник схватил дистанцию, в дневном режиме просто светится;

unsigned int Distance=0;                // Дистанция с ультрасоника;

//===================================================================================================================
// Setup
void setup()
{
  //Serial.begin(9600);
  pinMode(ledNight, OUTPUT);          // Ночной диод  ;
  pinMode(LedUltra,OUTPUT);        // Диод, индикатор "день" а ночью - чтобы видно было как действует ультрасоник;
  digitalWrite(LedUltra,LOW);

  for(i=0; i<15; i++)                // Режим работы PWM ног - выход;
  {
       pinMode(OutPins[i], OUTPUT);  
  }
 
}

//===================================================================================================================
// Loop
void loop()
{  
  NightIn();                                 // Получаем данные День/Ночь;
 //Serial.print(night);
 //Serial.print(" - boolean night");
 //Serial.println();
   
  if(night == 1)                            // Если ночь;
  {
       getDistance(pingPin00);            // Опрашиваем нижний ультрасоник;
       //Serial.print(Distance);
       //Serial.print(" - First Distance");
       //Serial.println();
       //delay(1000);
       if(Distance < 140)                   // Проверка дистанции для нижнего ультрасоника в сантиметрах (140 см.). Сделано для верхнего и нижнего раздельно.
     
       {
          SwitchOn();                       // Включаем подсветку снизу вверх;
         
          delay(SwitchOffDelay);                    // Ждем;
                   blink (timeForBlink);                // Померцаем;
          SwitchOff();                      // Выключаем подсветку;
       }
   
       getDistance(pingPin01);              // Опрашиваем верхний ультрасоник;
       //Serial.print(Distance);
       //Serial.print(" - Second Distance");
       //Serial.println();     
       //delay(1000);
       
       if(Distance < 55)                    // Проверка дистанции для нижнего ультрасоника в сантиметрах (55 см.).
       {
          SwitchOnDown();                   // Включаем подсветку сверху вниз;
          delay(SwitchOffDelay);            // Ждем;
          SwitchOffDown();                  // Выключаем подсветку;
       }     
   }
}
//====================================================================================================================

void SwitchOn()                                 // Включаем снизу вверх;
{
  digitalWrite(LedUltra, HIGH);
  for (i=0; i<15; i++)
  {
       analogWrite(OutPins[i], 254);                   // Зажигаем полностью первый сетодиод;
       delay(timer);                                   // Пауза перед следующим;
       if(i!=14)                                       // Проверяем, чтобы не включить несуществующий диод;
            {
               analogWrite(OutPins[i + 1], 254);       // Зажигаем полностью следующий светодиод;
               delay(timer);
            }
        if(i!=13)                                      // Проверяем, чтобы не включить несуществующий диод;
            {
                analogWrite(OutPins[i + 2], 254);      // Зажигаем полностью еще светодиод;
                delay(timer);
            }
       analogWrite(OutPins[i], SwitchOnBright);     // Слегка гасим подсветку;
       delay(timer);
  }
 }


void SwitchOff()                                   // Выключаем снизу вверх;
{  
  for (i=0; i<15; i++)
  {
        analogWrite(OutPins[i], 254);
        delay(timer);
       
        if(i!=14)
        {
            analogWrite(OutPins[i + 1], 254);
            delay(timer);
        }
       
        analogWrite(OutPins[i], 0);
        delay(timer);
   }
  digitalWrite(LedUltra, LOW);
}

//=====================================================================================================================

void SwitchOnDown()                              // Включаем сверху вниз;
  {
  digitalWrite(LedUltra, HIGH);  
   
  for (i=14; i > -1; i--)
  {
    analogWrite(OutPins[i], 254);
    delay(timer);
     
      if(i!=0)
      {
        analogWrite(OutPins[i - 1], 254);
        delay(timer);
      }  
   
   analogWrite(OutPins[i], SwitchOnBright);
   delay(timer*2);
  }
}


void SwitchOffDown()                                // Выключаем сверху вниз;
{  
  for (i=14; i > -1; i--)
  {
    analogWrite(OutPins[i], 254);
    delay(timer);
     
      if(i!=0)
      {
         analogWrite(OutPins[i - 1], 254);
         delay(timer);
      }
   
    analogWrite(OutPins[i], 0);
    delay(timer*2);
  }
  digitalWrite(LedUltra, LOW);
}
//=====================================================================================================================
unsigned int getDistance(int pingPin)                       // Чтение ультрасоника;
{    
 unsigned int duration = 0;
 pinMode(pingPin, OUTPUT);
 digitalWrite(pingPin, LOW);
 delayMicroseconds(2);
 digitalWrite(pingPin, HIGH);
 delayMicroseconds(15);
 digitalWrite(pingPin, LOW);
 delayMicroseconds(20);
 pinMode(pingPin, INPUT);
 duration = pulseIn(pingPin, HIGH);
 Distance = duration / 29 / 2;
         
 return Distance;
}
//===========================================================================================
boolean NightIn()                                        // Чтение день или ночь;
{
    sensorValue = 0;
    unsigned int a = 0, b = 0;
   
    for(i = 0; i < 50; i++)
    {
        sensorValue = analogRead(sensorPin);             // Чтение показаний датчика;
        if (sensorValue > sensorRef) a++;               // Увеличиваем а, если темнее референсного значения;
        if (sensorValue > (sensorRef - 25)) b++;         // Увеличиваем b, если темнее чем референсное значение минус допуск на гистерезис;
    }
   
    if ((night == 0) && (a > 49))                       // Если сейчас режим день и 50 раз значение датчика оказалось выше референсного,
    {                                                   // то переключаемся в ночной режим, включаем дежурную подсветку ступенек.
        digitalWrite(ledNight, HIGH);
        digitalWrite(LedUltra, LOW);
        analogWrite(2,NightBright );
        analogWrite(46,NightBright );
        night = 1;
    }
   
    if ((night == 1) && (b == 0))                      // Если сейчас режим ночь, и 50 раз значение датчика оказалось ниже референсного за
    {                                                  // вычетом запаса на гистерезис - включаем режим "день", гасим подсветку ступенек.
        digitalWrite(ledNight, LOW);
        digitalWrite(LedUltra, HIGH);
        analogWrite(2,0);
        analogWrite(46,0);
        night = 0;
    }
   
    else {}
   
    return night;
}
/*********************************************************************************************************************************************

Мерцание во время задержки

/*********************************************************************************************************************************************/

void blink (int timeForBlink)
{
        unsigned char brightness = 0;
       
        for (int a = 0; a < timeForBlink; a++)                                          // Цикл определяет длительность мерцания;
        {
            for(i = 1; i < 15; i++)                                                     // Мерцаем диодами;
            {
            brightness = random((SwitchOnBright-25), SwitchOnBright);
            analogWrite(OutPins[i], brightness);
            delay(2);                                                                   // Маленькая задержка;
            }
        }
   
        //for(i = 1; i < 15; i++)                                                           // Восстанавливаем свечение лестницы. Можно восстанавливать, можно не восстанавливать;
        //{
        //  analogWrite(OutPins[i], SwitchOnBright);
        //}
       
    return;
}